#coding:utf-8

'''
from JiuJiang
树莓酱的操作实例
https:://www.shumeijiang.com
'''
import sys
import RPi.GPIO as GPIO ##引入GPIO模块
import time    ##引入time库
#from mongo.mongoConn import mongoCon
from classes.motorAct import motorAct  #引入动作类
GPIO.setwarnings(False) 

#u型光电传感器
uPin = 17
GPIO.setmode(GPIO.BCM)
GPIO.setup(uPin, GPIO.IN, pull_up_down=GPIO.PUD_DOWN) #初始化u型光电低电压

#conn = mongoConn()
#动作实例化
motor = motorAct()

#定义多步操作
def walk(step, direction):
    if not step:
        return ;
    if not direction:
        direction = 'forward'

    run = 0
    roundStep = 600 #圈长 大于一圈的长度
    for i in range(0, roundStep):
        #if direction == 'backward':
        #    motor.oneStepBack(0.003)
        #else:
        tect = GPIO.event_detected(uPin)
        status = GPIO.input(uPin)

        #发现事件且处于高电平
        if tect == 1 and status == GPIO.HIGH:
            run += 1

        if direction == 'backward':
            motor.oneStepBack(0.003)
        elif direction == 'forward':
            motor.oneStep(0.003)

        #检测停止条件
        if run >= step:
            motor.stopMoving()
            break

        time.sleep(0.005)  ##每步间的间隔
        #print("第%d步" % i)
    return run

def getStep(step, maxStep):
    
    current = 1
    if step == current:
        return 0

    return (maxStep-step)+1

#执行步进
if __name__ == '__main__':
    try:

        find = raw_input("要寻找什么?")

        #记录每个格子存放的物品映射 这部分可灵活自定义
        address_map = {'瓜子':'one', '小刷子':'two', '螺丝刀':'three', '转换头':'four'}
        run = address_map[find]

        #物品注册位置映射
        if run == 'one':
            step = 1
        elif run == 'two':
            step = 2
        elif run == 'three':
            step = 3
        elif run == 'four':
            step = 4
        else:
            print('bad step')
            sys.exit()
        
        #动作注册
        GPIO.add_event_detect(uPin, GPIO.RISING, bouncetime=1000)

        #计算要走的步长 4是最大位置
        runStep = getStep(step, 4)

        #动作执行
        ret = walk(runStep, 'forward')  ##正向走对应步数
        time.sleep(1) #等待时间自定义
        walk(runStep, 'backward') ##反向走对应的步数
    except KeyboardInterrupt:
        pass

    GPIO.cleanup()
